#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

struct Student {
    int br_ind;
    char ime[100];
    float prosjek;
};
typedef struct Student Student;

char* get_field(char* line, int i) {
    char line_copy[1000];
    strcpy(line_copy, line);

    char* tok = strtok(line_copy, ",");
    int cnt = 0;

    while (tok != NULL) {
        if (cnt == i) {
            return tok;
        }
        else {
            tok = strtok(NULL, ",");
            cnt++;
        }
    }

    return NULL;
}

void studenti() {
    FILE* f_ptr = fopen("studenti.txt", "r");
    FILE* neparni = fopen("neparni.txt", "w");
    FILE* parni = fopen("parni.txt", "w");

    if (f_ptr == NULL || neparni == NULL || parni == NULL) {
        printf("Fajl nije uspjesno otvoren.\n");
    }
    else {
        char line[1000];
        fscanf(f_ptr, "%s", line);
        char* temp;

        while (!feof(f_ptr)) {
            //printf("%s\n", line);

            char* ime_prez = get_field(line, 0);
            //printf("%s\n", get_field(line, 0));

            temp = get_field(line, 1);
            int br_ind;
            sscanf(temp, "%d", &br_ind);
            //printf("%d\n", br_ind);

            temp = get_field(line, 2);
            float prosjek;
            sscanf(temp, "%f", &prosjek);
            //printf("%.1f\n", prosjek);

            if (br_ind % 2 == 1) {
                fprintf(neparni, "%s,%d,%.1f\n", ime_prez, br_ind, prosjek);
            }
            else {
                fprintf(parni, "%s,%d,%.1f\n", ime_prez, br_ind, prosjek);
            }

            fscanf(f_ptr, "%s", line);
        }

        printf("OK\n");

        fclose(f_ptr);
        fclose(neparni);
        fclose(parni);
    }
}

/** za vjezbu:
posmatrati prosjek
A (9.0 - 10), B (8.0 - 9.0) ...
studenti.txt -> A.txt, B.txt ...

po smjerovima (A,B,C,D)
*/

void rijeci(char* line) {
    char line_copy[1000];
    strcpy(line_copy, line);

    char* tok = strtok(line_copy, " ");

    while (tok != NULL) {
        if (tok[strlen(tok)-1] == '\n') {
            printf("Novi red, %s\n", tok);
        }

        printf("%s\n", tok);
        tok = strtok(NULL, " ");
    }
}

void brojanje_karaktera() {
    FILE* ulaz = fopen("ulaz.txt", "r");
    FILE* izlaz = fopen("izlaz.txt", "w");

    if (ulaz == NULL || izlaz == NULL) {
        printf("Fajl nije uspjesno otvoren.\n");
    }
    else {
        int counts[26] = {0};
        char line[1000];
        fscanf(ulaz, "%s", line);

        while (!feof(ulaz)) {
            rijeci(line);

            int i = 0;
            while (line[i] != '\0') {
                // islower(line[i])
                if ('a' <= line[i] && line[i] <= 'z') {
                    counts[line[i] - 'a']++;
                }
                i++;
            }

            fscanf(ulaz, "%s", line);
        }

        int i;
        for (i = 0; i < 26; i++) {
            if (counts[i] > 0) {
                fprintf(izlaz, "%c: %d\n", 'a'+i, counts[i]);
            }
        }

        printf("OK\n");

        fclose(ulaz);
        fclose(izlaz);
    }
}

/**
za vjezbu

u izlaz.txt presuti sve rijeci duze od 5 karaktera

koristiti strtok sa " "
*/

int main()
{
    /// rad sa sekvencijalnim fajlovima

    /*int x;
    FILE* f_ptr = fopen("primjer1.txt", "a");

    if (f_ptr == NULL) {
        printf("Fajl nije uspjesno otvoren.\n");
    }
    else {
        scanf("%d", &x);
        while (!feof(stdin)) {
            fprintf(f_ptr, "%d\n", x);
            scanf("%d", &x);
        }
        fclose(f_ptr);
    }*/

    /*int x;
    FILE* f_ptr = fopen("primjer1.txt", "r");

    if (f_ptr == NULL) {
        printf("Fajl nije uspjesno otvoren.\n");
    }
    else {
        fscanf(f_ptr, "%d", &x);
        while (!feof(f_ptr)) {
            printf("%d\n", x);
            fscanf(f_ptr, "%d", &x);
        }
        fclose(f_ptr);
    }*/

    /// rad sa fajlovima sa slucajnim pristupom

    /*struct Student s = {1, "Marko", 7.8};
    printf("%d %s %f\n", s.br_ind, s.ime, s.prosjek);

    struct Student* s_ptr = &s;
    printf("%p\n", s_ptr);
    printf("%d %s %f\n", (*s_ptr).br_ind, (*s_ptr).ime, (*s_ptr).prosjek);
    printf("%d %s %f\n", s_ptr->br_ind, s_ptr->ime, s_ptr->prosjek);*/

    studenti();
    brojanje_karaktera();

    return 0;
}
